using System;
using Gtk;
using Sugar;
using Pango;

public partial class MainWindow: Sugar.Window // Gtk.Window
{	
	Morpion.Morpion m;
	Gdk.Pixbuf pixVide, pixCroix, pixRond;
	Image[,] images;
	bool bJeuxEnCours;
		
	//public MainWindow (): base (Gtk.WindowType.Toplevel)
	public MainWindow (string activityId, string bundleId)
		:base ("Morpion",activityId, bundleId)
	{
		Mono.Unix.Catalog.Init( "MorpionSugar","./locale");   // pour l'internationnalisation
		Build ();   // construction des objet en fonction du xml designer
		// pbm de la taille du label
		// Table des images
		// attention si pas de icone standard dans "icônes prédéfinies" : l'outil ne crée pas IconLoader !
		pixVide = new Gdk.Pixbuf(System.IO.Path.Combine(System.AppDomain.CurrentDomain.BaseDirectory, "./Vide.png"));
		pixRond = new Gdk.Pixbuf(System.IO.Path.Combine(System.AppDomain.CurrentDomain.BaseDirectory, "./Rond.png"));
		pixCroix = new Gdk.Pixbuf(System.IO.Path.Combine(System.AppDomain.CurrentDomain.BaseDirectory, "./Croix.png"));
		
		images = new Image[3,3];
		
		for (uint i = 0; i < 3; i++)
			for (uint j = 0; j < 3; j++)
				{
					images[i,j] = new Gtk.Image();
					images[i,j].PixelSize = 128;
					table1.Attach( images[i,j], i, i+1, j, j+1);
				}
		label1.Style.FontDescription.Size = 600;
	    NouveauJeu();
	}
void NouveauJeu()
	{
    	m = new Morpion.Morpion();  // création du modèle du jeux
		MAJ();   // mettre à jour les éléments de la fenêtre
		bJeuxEnCours = true;
		label1.Text = Mono.Unix.Catalog.GetString("Cliquer sur la case de votre choix");
		label1.Layout.FontDescription = FontDescription.FromString ("Tahoma 15");		

	}
	
	
	protected void OnDeleteEvent (object sender, DeleteEventArgs a)
	{
		Application.Quit ();
		a.RetVal = true;
	}

	
	protected virtual void OnShown (object sender, System.EventArgs e)
	{// buffer containing an image 
       
	}
	
	void MAJ()
	{
     for (int i = 0; i < 3; i++)
			for (int j = 0; j < 3; j++)
				switch (m.Donne(i,j))
			    {
					case Morpion.Morpion.Etat.Vide:
		            	images[i,j].Name = "Vide";
  		            	images[i,j].Pixbuf = pixVide;
  						break;
        			case Morpion.Morpion.Etat.Croix:
		            	images[i,j].Name = "Croix";
  		            	images[i,j].Pixbuf = pixCroix;
  						break;
        			case Morpion.Morpion.Etat.Rond:
		            	images[i,j].Name = "Rond";
  		            	images[i,j].Pixbuf = pixRond;
  						break;
					default:
						break;
				}
        				
		table1.ShowAll();
	}

	

	protected virtual void OnButtonPressEvent (object o, Gtk.ButtonPressEventArgs args)
	{
		
		if (!bJeuxEnCours)
			return;
		
		// trouver la case activée
		int x = (int)args.Event.X;
		int y = (int)args.Event.Y;
		int l, h;
		GetSize( out l, out h);
		if (m.CroixJoue( x *3 /l, y * 3 / h))
		{
				label1.Text = Mono.Unix.Catalog.GetString("Croix gagne");
				bJeuxEnCours = false;
		}
		else if ( m.RondJoue())  // c'est l'ordinateur qui joue
		{
				label1.Text = Mono.Unix.Catalog.GetString("Rond gagne");
				bJeuxEnCours = false;
		} 
		else if (m.Plein())
		{
			bJeuxEnCours = false;
			label1.Text = Mono.Unix.Catalog.GetString("Jeu nul");
		}
		   else
		    label1.Text = Mono.Unix.Catalog.GetString("Rejouer");
		// taille de l'affichage
		label1.Layout.FontDescription = FontDescription.FromString ("Tahoma 20");
						
		MAJ();
	}

	protected virtual void OnStopActionActivated (object sender, System.EventArgs e)
	{
		Application.Quit();
	}

	protected virtual void OnMediaPlayActionActivated (object sender, System.EventArgs e)
	{
		NouveauJeu();
	}
}