
using System;

namespace Morpion
{
	
	
	public class Morpion
	{
		public enum Etat { Vide, Rond, Croix};
		
		Etat[,] table;
		//Random rnd;
		
		public Morpion()
		{ 
			table = new Etat[3, 3];
			
			for (int i = 0; i < 3; i++)
			for (int j = 0; j < 3; j++)
				 table[i, j]= Etat.Vide;					
			//rnd = new Random();
		}
		
		public bool RondJoue( int i, int j)
		{
			if (table[ i, j]== Etat.Vide)
			{
				table[i,j] = Etat.Rond;
				return Gagne()!=Etat.Vide;
			}
			else
				return false;
		}
		public bool RondJoue()  // vrai si rond gagne
		{
			
			 // première stratégie
		/*	switch (rnd.Next(3))
			{
			 	case 0 :
				    return Strategie1();
				case 1 :
				    return Strategie2();
				case 2 :
				    return Strategie3();
				case 3 :
				    return Strategie4();
				default:
					return false;
			}*/
			return MinMax();  // deuxième essai
		}
		Morpion Clone()
		{
			Morpion m = new Morpion();
			for (int i = 0; i < 3; i++)
			for (int j = 0; j < 3; j++)
				 m.table[i, j] = table[ i, j];					
			return m;
		}
		bool MinMax() 
		{
			Morpion ma = Clone();  // faire une copie du morpion
			// essayer les 9 possibilités
			int minmax = -20;
			int iMax=0, jMax = 0;
				
			for (int i = 0; i < 3; i++)
			for (int j = 0; j < 3; j++)
				 if (ma.table[i, j]== Etat.Vide)
				 {
					ma.table[i, j] = Etat.Rond;
				    int iMinMax = ma.Max( Etat.Rond);
				    if (iMinMax==3)
					{
						table[i, j] = Etat.Rond;
						return true;  // stratégie gagnante !
					}
					iMinMax = ma.MinCroix( );
						
				    ma.table[i, j]= Etat.Vide;  // état initial
					if (iMinMax > minmax)
					{
						minmax = iMinMax;
						iMax = i;
						jMax = j;
					}
				}
			if (table[iMax, jMax]== Etat.Vide)
				table[iMax, jMax] = Etat.Rond;
			return false;	
		}
		int MinCroix( )  // un niveau calcule du minmax seul
		{
			Morpion ma = Clone();  // faire une copie du morpion
			// essayer les 9 possibilités
			int minmax = 0;
				
			for (int i = 0; i < 3; i++)
			for (int j = 0; j < 3; j++)
				if (ma.table[i, j]== Etat.Vide)
				{
					ma.table[i, j] = Etat.Croix;
				    int iMinMax = - ma.Max( Etat.Croix);
				    if (iMinMax==-3)
					   return -3;  // stratégie perdante !
					
					if (ma.Plein())
						return 0;    // partie nulle
					iMinMax = ma.MaxRond();
					
					ma.table[i, j]= Etat.Vide;
					if (iMinMax < minmax)
						minmax = iMinMax;
							
				}
			return minmax;
		}
		int MaxRond( )  // un niveau calcule du minmax seul
		{
			Morpion ma = Clone();  // faire une copie du morpion
			// essayer les 9 possibilités
			int minmax = 0;
				
			for (int i = 0; i < 3; i++)
			for (int j = 0; j < 3; j++)
				if (ma.table[i, j]== Etat.Vide)
				{
					ma.table[i, j] = Etat.Rond;
				    int iMinMax = ma.Max( Etat.Rond);
				    if (iMinMax==3)
					   return 3;  // gagnante
					
					if (ma.Plein())
						return 0;    // partie nulle
					iMinMax = ma.MinCroix( );
					
					ma.table[i, j]= Etat.Vide;
					if (iMinMax > minmax)
						minmax = iMinMax;
							
				}
			return minmax;
		}
		
		bool Strategie1()
		{
			for (int i = 0; i < 3; i++)
			for (int j = 0; j < 3; j++)
				 if (table[i, j]== Etat.Vide)
					return	RondJoue( i, j);					
						
			return false;
		}
		bool Strategie2()
		{
			for (int j = 0; j < 3; j++)
			for (int i = 0; i < 3; i++)
				 if (table[i, j]== Etat.Vide)
					return	RondJoue( i, j);					
						
			return false;
		}
		bool Strategie3()
		{
			for (int j = 2; j >= 0; j--)
			for (int i = 2; i >= 0; i--)
				 if (table[i, j]== Etat.Vide)
					return	RondJoue( i, j);					
						
			return false;
		}
		bool Strategie4()
		{
			for (int j = 2; j >= 0; j--)
			for (int i = 2; i >= 0; i--)
				 if (table[i, j]== Etat.Vide)
					return	RondJoue( i, j);					
						
			return false;
		}
			
		public bool CroixJoue( int i, int j) // vrai si Croix gagne
		{
			if (table[ i, j]== Etat.Vide)
			{
				table[i,j] = Etat.Croix;
				
				return Gagne()!=Etat.Vide;
			}
			else
				return false;
		}
		public Etat Donne( int i,int j)
		{
			return table[ i, j];
		}
		
		public Etat Gagne()
		{
			
			if (Max( Etat.Croix)==3)
				return Etat.Croix;
			if (Max( Etat.Rond)==3)
				return Etat.Rond;
			
			return Etat.Vide;
		}
		public bool Plein()
		{
			for (int i = 0; i < 3; i++)
			for (int j = 0; j < 3; j++)
				 if (table[i, j]== Etat.Vide)
					return false;	// au moins 1 vide				
						
			return true; // plein
		}
		public int Max(Etat e)
		{
			int iMax = 0;
			// Parcourir les verticales
			for (int i = 0; i < 3; i++)
			    if ( table[ i, 0] == e && table[ i, 1]== e && table[ i, 2]== e)
					return  3;
				else if (( table[ i, 0] == e && table[ i, 1]== e) || ( table[ i, 1] == e && table[ i, 2]== e))
			        iMax = 2;
				else if ( table[ i, 0] == e || table[ i, 1]== e || table[ i, 2]== e)
					iMax = 1;
				
				
			// Parcourir les horizontale
			for (int j = 0; j < 3; j++)
			    if ( table[ 0, j] == e && table[ 1,j]== e && table[ 2, j]== e)
					return  3;
				else if (( table[ 0, j] == e && table[ 1, j]== e) || ( table[ 1, j] == e && table[ 2, j]== e))
			        iMax = 2; 
				
			
			
			// parcourir toute les diagonales
			if ( table[ 0, 0] == e && table[ 1, 1]==e && table[ 2, 2]==e)
					return 3;
			if ( table[ 0, 2] == e && table[ 1, 1]==e && table[ 2, 0]==e)
					return 3;
			
			
			if (( table[ 0, 0] == e && table[ 1, 1]==e ) || ( table[ 1, 1]==e && table[ 2, 2]==e))
				iMax = 2;
			if ( (table[ 0, 2] == e && table[ 1, 1]==e ) || ( table[ 1, 1]==e && table[ 2, 0]==e))
			    iMax = 2;
			
					
			return iMax;
		}
	}
}
